# NAME

NWS Warnings - A Weather Source API

NWS advisories, watches and warnings for latitude/longitude points and OnPoint™ points. The Weather Source NWS Warnings API is built upon the [OnPoint™ Platform](https://weathersource.com/products/onpoint-platform/) which ensures data that is gap-free, homogeneous, and ready for immediate analysis. We offer the highest resolution grid on the market, covering every landmass in the world and up to 200 miles offshore.      **IMPORTANT:** To authenticate to the Weather Source NWS Warnings API, each request must contain your API key set to a custom header named `X-API-KEY`. If you do not have a Weather Source API key [sign up for a free 30-day developer account](https://developer.weathersourceapis.com/account/sign-up/). You may use the evaluation API Key `C0W60UOFRML47ytbXk4xlLBfv` to access example locations found in this documentation.      When using the \\\"Try it out\\\" capability in the documentation, the API key should be added by clicking the green \\\"Authorize\\\" button at the top of the page. 

# VERSION

Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 2.0.0
- Package version: 
- Build package: io.swagger.codegen.v3.generators.scala.ScalaClientCodegen
For more information, please visit [https://developer.weathersourceapis.com/](https://developer.weathersourceapis.com/)

# Requirements

Building the API client library requires [Maven](https://maven.apache.org/) to be installed.

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn deploy
```

Refer to the [official documentation](https://maven.apache.org/plugins/maven-deploy-plugin/usage.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
    <groupId>io.swagger</groupId>
    <artifactId>swagger-scala-client</artifactId>
    <version>1.0.0</version>
    <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "io.swagger:swagger-scala-client:1.0.0"
```

### SBT users

```scala
libraryDependencies += "io.swagger" % "swagger-scala-client" % "1.0.0"
```

## Documentation for API Endpoints

All URIs are relative to *https://nwswarnings.weathersourceapis.com/v2*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*OnpointsApi* | [**onpointsOnpointIdGet**](OnpointsApi.md#onpointsOnpointIdGet) | **GET** /onpoints/{onpointId} | NWS advisories, watches and warnings for an OnPoint™ point.
*PointsApi* | [**pointsLatitudelongitudeGet**](PointsApi.md#pointsLatitudelongitudeGet) | **GET** /points/{latitude},{longitude} | NWS advisories, watches and warnings for a Latitude/Longitude point.

## Documentation for Models

 - [BoundingPoints](BoundingPoints.md)
 - [BoundingPointsInner](BoundingPointsInner.md)
 - [CountryCode](CountryCode.md)
 - [CountryName](CountryName.md)
 - [Distance](Distance.md)
 - [Elevation](Elevation.md)
 - [ErrorObj](ErrorObj.md)
 - [FieldListObj](FieldListObj.md)
 - [Fields](Fields.md)
 - [Grid](Grid.md)
 - [Latitude](Latitude.md)
 - [Longitude](Longitude.md)
 - [NwsWarningsArr](NwsWarningsArr.md)
 - [NwsWarningsObj](NwsWarningsObj.md)
 - [NwsWarningsOnpointObj](NwsWarningsOnpointObj.md)
 - [NwsWarningsPointObj](NwsWarningsPointObj.md)
 - [OnpointId](OnpointId.md)
 - [OnpointObj](OnpointObj.md)
 - [PhenomCode](PhenomCode.md)
 - [PhenomDesc](PhenomDesc.md)
 - [PointObj](PointObj.md)
 - [Significance](Significance.md)
 - [SubdivCode](SubdivCode.md)
 - [SubdivName](SubdivName.md)
 - [TimestampExpires](TimestampExpires.md)
 - [Timezone](Timezone.md)

## Documentation for Authorization

Authentication schemes defined for the API:
### ApiKeyAuth

- **Type**: API key
- **API key parameter name**: X-API-KEY
- **Location**: HTTP header



# BUILDING YOUR LIBRARY

See the homepage `https://github.com/swagger-api/swagger-codegen` for full details.
But briefly, clone the git repository, build the codegen codebase, set up your build
config file, then run the API build script. You will need git, Java 7 or 8 and Apache
maven 3.0.3 or better already installed.

Your library files will be built under `WWW::MyProjectName`.

          $ git clone https://github.com/swagger-api/swagger-codegen.git
          $ cd swagger-codegen
          $ mvn package
          $ java -jar modules/swagger-codegen-cli/target/swagger-codegen-cli.jar generate \
    -i [URL or file path to JSON swagger API spec] \
    -l akka-scala \
    -c /path/to/config/file.json \
    -o /path/to/output/folder

Bang, all done. Run the `autodoc` script in the `bin` directory to see the API
you just built.

## Author

support@weathersource.com
